﻿package com.Tutorial 
{
    import com.adamatomic.flixel.*;
	import flash.geom.Rectangle;
	import com.Tutorial.Mother;
	
	/**
	 * ...
	 * @author Stephen Lavelle
	 */
	public class NameEntryState extends FlxState
	{				
		public static var leftBorder:Number = 15;

		static public var _name:String="tittienutf";
		private var _nameTxt:FlxText;
		private var _generated:FlxText;
		private var _star:FlxText;
		private var _derrida:FlxText;
		
		public function NameEntryState() 
		{	
			_name = "";
			FlxG.setMusic(MenuState.Mus1);
			this.add(new FlxText(0, 50, FlxG.width, 100, "enter name:", 0xffffffff, null, 20, "center"));
			
			_nameTxt = new FlxText(0, 100, FlxG.width, 120, "_", 0xffffff, null, 18, "center");
			this.add(_nameTxt);
						
			var offset:Number;
			offset = "a".charCodeAt();
			for (var i:int = 0; i < 26; i++)
			{
				FlxG.setCursor(MenuState.ImgCursor);

				var char:String = String.fromCharCode(offset + i);
				var lb:LetterButton = new LetterButton(char,_addLetter);
				this.add(new FlxButton(
					leftBorder + 17 * (i%13),
					140 + 19 * Math.floor(i / 13),					
					new FlxSprite(null,0,0,false,false,15,17,0xffffffff),
					lb.action,
					new FlxSprite(null, 0, 0, false, false, 15, 17, 0x000000), 
					new FlxText(0, 0, 15, 17, char, 0xff000000, null, 12, "center"),
					new FlxText(0, 0, 15, 17, char, 0xffffffff, null, 12, "center")
					));
			}
					//add 'back' button

				this.add(new FlxButton(
					leftBorder + 17 * 7 ,
					140 +19*2,					
					new FlxSprite(null,0,0,false,false,3*17-2,17,0xffffffff),
					_backSpace,
					new FlxSprite(null, 0, 0, false, false, 3*17-2, 17, 0x000000), 
					new FlxText(0, 0, 3*17-2, 17, "del", 0xff000000, null, 12, "center"),
					new FlxText(0, 0, 3*17-2, 17, "del", 0xffffffff, null, 12, "center")
					));
					
					this.add(new FlxButton(
					leftBorder + 17 * 10 ,
					140 +19*2,					
					new FlxSprite(null,0,0,false,false,3*17-2,17,0xffffffff),
					_done,
					new FlxSprite(null, 0, 0, false, false, 3*17-2, 17, 0x000000), 
					new FlxText(0, 0, 3*17-2, 17, "done", 0xff000000, null, 12, "center"),
					new FlxText(0, 0, 3*17-2, 17, "done", 0xffffffff, null, 12, "center")
					));
		}
		
		private function _updateText():void
		{
			if (_name.length<12)
				_nameTxt.setText(_name + "_");
			else
				_nameTxt.setText( _name );				
		}
		override public function update():void
        {
			super.update();
			
		}
		
		private function _addLetter( s:String):void
		{
			if (_name.length < 10)
			{
				_name += s;	
				_updateText()
			FlxG.play(MenuState.Blip, 0.5);	
			}
		}
		
		private function _backSpace():void
		{
			if (_name.length > 0)
			{
				_name = _name.substring(0, _name.length - 1);
				_updateText();
			FlxG.play(MenuState.Blip, 0.5);	
			}
		}
		
		private function _done():void
		{
			FlxG.switchState(WalkState);
			FlxG.play(MenuState.Blip, 0.5);	
		}
		
		
	}
}

class LetterButton {
	private var _letter:String;
	private var _clickFunction:Function;
	public function LetterButton(l:String,f:Function)
	{
		_letter = l;
		_clickFunction = f;
	}
	
	public function action():void
	{
		_clickFunction(_letter);
	}
}